## sorcer-1.1.3-3.src.tar.gz

=== CMakeLists.txt ===

cmake_minimum_required (VERSION 2.6)

project (sorcer)

set(SORCER_VERSION_MAJOR "1")
set(SORCER_VERSION_MINOR "1")
set(SORCER_VERSION_PATCH "2")

set(SORCER_VERSION "${SORCER_VERSION_MAJOR}.${SORCER_VERSION_MINOR}.${SORCER_VERSION_PATCH}")

option(RELEASE_BUILD  "Build for production usage" ON )

find_package(PkgConfig)

#SET(CMAKE_INSTALL_PREFIX "/usr" )

pkg_check_modules(LV2 lv2 REQUIRED)
include_directories( ${LV2_INCLUDE_DIRS}  )

pkg_check_modules(NTK ntk REQUIRED)
include_directories( ${NTK_INCLUDE_DIRS}  )
link_directories   ( ${NTK_LIBRARY_DIRS}  )

SET(CMAKE_SHARED_LINKER_FLAGS "-fPIC -shared -Wl,-z,nodelete -Wl,--no-undefined")

IF(RELEASE_BUILD)
  SET(CMAKE_CXX_FLAGS "-g -Wall -Wno-unused-variable -msse2 -mfpmath=sse -ffast-math")
  SET(CMAKE_C_FLAGS "-g -Wall -W -Wno-unused-variable -msse2 -mfpmath=sse -ffast-math")
ENDIF()

## The following commands will re-generate the .cpp files from the FAUST .dsp,
## and extract the .ttl info from them, patch the custom UI URI's in, and copy
## them to the sorcer.lv2 folder.
##
## Note: This is *NOT* necessary for packaging, as the generated files are commited
## in the repo to remove the dependency on FAUST, and to easy packaging.
##
#  cd faust/ 
#  g++ -fPIC -shared -ffast-math -O3 -DPLUGIN_URI='"http://www.openavproductions.com/sorcer"'  -Wl,-z,nodelete main.cpp -o sorcer.so
#  g++ -DPLUGIN_URI='"http://www.openavproductions.com/sorcer"' main.cpp
#  ./a.out > sorcer.ttl
#  patch -u sorcer.ttl ../addUiRdf.patch
#  cp sorcer.so  ../sorcer.lv2/
#  cp sorcer.ttl ../sorcer.lv2/
#  cd ..

# tells FAUST to use the following URI for the plugin
ADD_DEFINITIONS( -DPLUGIN_URI="http://www.openavproductions.com/sorcer" )

# print config
string( ASCII 27 _esc)

function(COLOR_MESSAGE TEXT)
    if(CMAKE_COLOR_MAKEFILE)
        MESSAGE(${TEXT})
    else()
        string(REGEX REPLACE "${_esc}.[0123456789;]*m" "" __TEXT ${TEXT} )
        MESSAGE(${__TEXT})
    endif()
endfunction()

SET(green     "${_esc}[1;32m")
SET(blue      "${_esc}[1;34m")
SET(reset     "${_esc}[1;0m")

COLOR_MESSAGE( "
  ${blue}Sorcer Configuration : ${SORCER_VERSION}${reset}
-----------------------
* ${green}Install Directory${reset}               : ${CMAKE_INSTALL_PREFIX}\n" )
# /print config



FILE(GLOB sources faust/main.cpp +
  gui/sorcer_widget.cxx +
  gui/sorcer_ui.cxx )

ADD_LIBRARY(sorcer SHARED ${sources})

target_link_libraries( sorcer ${NTK_LIBRARIES}     )
#target_link_libraries( sorcer ${SNDFILE_LIBRARIES} )

# Remove "lib" part before name (sorcer.so, not libsorcer.so)
set_target_properties(sorcer PROPERTIES PREFIX "")

# add the install targets
install (TARGETS sorcer DESTINATION lib/lv2/sorcer.lv2/)

# install .ttl files
install(FILES "sorcer.lv2/sorcer.ttl"     DESTINATION lib/lv2/sorcer.lv2/)
install(FILES "sorcer.lv2/manifest.ttl"  DESTINATION lib/lv2/sorcer.lv2/)

=== PKGBUILD ===
# Maintainer: David Runge <dvzrv@archlinux.org>

pkgname=sorcer
pkgver=1.1.3
pkgrel=3
pkgdesc="A polyphonic wavetable synth LV2 plugin"
arch=('x86_64')
url="http://openavproductions.com/sorcer"
license=('GPL3')
groups=('lv2-plugins' 'pro-audio')
depends=('cairo' 'gcc-libs' 'glibc')
makedepends=('boost' 'cmake' 'lv2' 'ntk')
checkdepends=('lv2lint')
source=("$pkgname-$pkgver.tar.gz::https://github.com/openAVproductions/openAV-${pkgname}/archive/release-${pkgver}.tar.gz"
        "${pkgname}-1.1.3-lv2-1.18.0.patch::https://github.com/openAVproductions/openAV-Sorcer/pull/26/commits/0c06a2f89a44a8e275f0a592c3ac946eff7b7020.patch"
        "${pkgname}-1.1.3-cmake.patch::https://github.com/openAVproductions/openAV-Sorcer/pull/27/commits/d3be525b6b2fd508658b608bbb52d75d9b85a8ca.patch"
)
sha512sums=('d03db6b7d62e785c0428636a0d0f77cbbfd6991f994bccb120317a96a9866e978fae66e6dd0c6a6cd2763147f427bb7ba20f01cd06356797042ff42caaa1eab0'
            '45c5392ad897252490ff59d3cd71df1f9f1120926b53f7bba5ece49f08315c5f2d16ca982aaa1ab8e6fe2e6c02b7dae7b79d75d411f3b169b8ab9f1ad63ed570'
            '2d94f6289d5ef1728e8b22ca3dde3a0506dc9a30259499be4b551dbd0af2384009b943ff366033f49bf9087f38d2dde56ea7672249dcf97fc9d6f2bec230a4d4')

prepare() {
  mv -v "openAV-Sorcer-release-${pkgver}" "$pkgname-$pkgver"
  cd "$pkgname-$pkgver"
  # fixing build with lv2 >= 1.18.0
  patch -Np1 -i "../${pkgname}-1.1.3-lv2-1.18.0.patch"
  # making sure cmake respects external CFLAGS/CXXFLAGS/LDFLAGS
  patch -Np1 -i "../${pkgname}-1.1.3-cmake.patch"
}

build() {
  cd "$pkgname-$pkgver"
  export CFLAGS+=" ${CPPFLAGS}"
  export CXXFLAGS+=" ${CPPFLAGS}"
  cmake -DCMAKE_INSTALL_PREFIX='/usr' \
        -DCMAKE_BUILD_TYPE='None' \
        -Wno-dev \
        -B build \
        -S .
  make VERBOSE=1 -C build
}

check() {
  cd "$pkgname-$pkgver"
  cp -v "build/${pkgname}.so" "${pkgname}.lv2"
  lv2lint -Mpack -I "${pkgname}.lv2" "http://www.openavproductions.com/sorcer" || echo "Known issues: https://github.com/openAVproductions/openAV-Sorcer/issues/28"
  rm -v "${pkgname}.lv2/${pkgname}.so"
}

package() {
  depends+=('libntk.so')
  cd "$pkgname-$pkgver"
  make DESTDIR="$pkgdir/" install -C build
  install -vDm 644 README.md -t "${pkgdir}/usr/share/doc/${pkgname}/"
}
